/*
** CONFIG.C
**
** Configuracion.
**
**
** (c) 1.997-99 Jesus Cea Avion
** jcea@argo.es
** http://www.argo.es/~jcea/
** http://www.argo.es/~jcea/artic/radius02.htm
**
** Lea las condiciones de uso y distribucion
** en el fichero "COPYING".
**
**
** 14/Dic/98 Version 1.0
**           Este fichero permite tener en un unico
**           lugar, pero fuera de la libreria, la
**           la configuracion necesaria para todos
**           los programas que usan la libreria en si.
**
** 17/Dic/98 Soporte para modulo de salida generico.
**
** 30/Dic/98 Se continua la migracion al modulo
**           generico de salida.
**
** 04/Dic/98 Se cambian de sitio las rutinas "str2tiempo"
**           y "tiempo2str".
*/

#include "lee_log.h"
#include "lee_radius.h"
#include "lee_mrtg.h"
#include "config.h"
#include "salida.h"
#include "salida_html.h"
#include <stdlib.h>
#include <stdio.h>


#define MAX_TIEMPO  0x7fffffff
time_t tiempo_inicial=0;
time_t tiempo_final=MAX_TIEMPO;

/*
** Clase C. Ojo con el punto final.
** Por ejemplo, "192.168.1."
*/

char *RED[]={
  "PON_TU_SERIE_DE_CLASES_C",
  NULL};

/* Tabla para asignar usuarios fijos a determinadas IPs fijas */

t_ip_usuario IP_USUARIO[]={
  {NULL,NULL}};

/* La clave a usar en el CGI */

char *CLAVE="TU_CLAVE_DE_ACCESO";

/* Directorio donde estan los archivos historicos */

char *D_HISTORICO="PON_EL_PATH_A_LOS_ARCHIVOS_HISTORICOS/";

/* STUBS para rutinas de lectura de registros */

static t_log RADIUS = {
  abre_log_detalle_radius,
  cierra_log_detalle_radius,
  lee_registro_detalle_radius
};

log_estado lee_registro_detalle_radius_infovia_plus(registro_log *registro);
static t_log RADIUS_IPLUS = {
  abre_log_detalle_radius,
  cierra_log_detalle_radius,
  lee_registro_detalle_radius_infovia_plus
};

static t_log MRTG = {
  abre_log_mrtg,
  cierra_log_mrtg,
  lee_registro_mrtg
};

/*
** Define las rutinas que se van a utilizar para la salida
*/
t_salida SALIDA = {
  salida_cabecera_html,
  salida_conexiones_html,
  salida_final_html
};

/*
** Ficheros de detalle del RADIUS.
** El final se marca con una cadena vacia.
*/

#define ISP  "@PON_TU_CPI_SI_TIENES_ALIAS"


t_accounting accounting[]={
  {"TU_SERVIDOR_DE_TUNELES",ISP,&RADIUS_IPLUS   /* Tuneles */   },
  {"/export/home/snmp/","",&MRTG  /* Estadisticas MRTG */ },
  {NULL,NULL,NULL}}; /* Marcador final */





/*
** Rutinas generales
*/



/*
** Como el servidor de tuneles de Infovia Plus
** no indica el Caller ID, pues lo indicamos
*/
log_estado lee_registro_detalle_radius_infovia_plus(registro_log *registro)
{
log_estado estado;

  estado=lee_registro_detalle_radius(registro);
  if(registro->caller_id[0]=='\0') strcpy(registro->caller_id,"Infov&iacute;a Plus");
  return estado;
}

/*
** El tiempo convertido es local, no UTC
** Parece ignorar los "daylight saving"
*/
time_t str2tiempo(char *tiempo)
{
struct tm tm;

  strptime(tiempo,"%Y%m%d%H%M",&tm);
  return mktime(&tm);
}

void tiempo2str(char *buf,time_t tiempo)
{
struct tm *tm;

  tm=localtime(&tiempo);
  strftime(buf,CAMPO_LONG,"%Y%m%d%H%M",tm);
}

/*
** clipping_mensual
** Esta rutina devuelve un valor en segundos que
** se corresponde con:
** - El principio del mes en curso
** - El principio del mes anterior si el mes en
**   curso tiene menos de cuatro horas de vida.
*/
time_t clipping_mensual(void)
{
char buf[CAMPO_LONG];
unsigned long i;

  tiempo2str(buf,time(NULL));
  if((buf[6]=='0')&&(buf[7]=='1')&&
    (buf[8]=='0')&&(buf[9]<'4')) /* 4 horas */
  {
    buf[6]='\0';
    i=atol(buf);
    i-=1;
    if(!(i%100)) i-=88; /* Quita uno al ano y pone mes doce */
    sprintf(buf,"%lu010000",i);
  }
  else
  {
    strcpy(buf+6,"010000"); /* Desde el principio del mes */
  }
  return str2tiempo(buf);
}

void activa_clipping_mensual(int num_tiempos,char *tiempos[])
{
  if(num_tiempos<1) /* No se indican los tiempos */
  {
    tiempo_inicial=clipping_mensual();
  }
  else
  {
    tiempo_inicial=str2tiempo(tiempos[0]);
    if(num_tiempos>1) tiempo_final=str2tiempo(tiempos[1]);
  }
}

